//
//  GeolocationHelper.swift
//  Serloc
//
//  Created by Joaquim Calvo Gubianas on 09/05/2018.
//  Copyright © 2018 Joaquim Calvo Gubianas. All rights reserved.
//

import Foundation
import CoreLocation

class  GeolocationHelper : NSObject, CLLocationManagerDelegate {
    
    private static var instance : GeolocationHelper? = nil
    private let locationManager = CLLocationManager()
    
    private override init() {
        super.init()
        
        self.locationManager.delegate = self
        self.locationManager.distanceFilter = kCLLocationAccuracyNearestTenMeters
        self.locationManager.desiredAccuracy = kCLLocationAccuracyBest
        self.locationManager.startUpdatingLocation()
    }
    
    public static func initGeolocation() {
        GeolocationHelper.instance = GeolocationHelper()
    }
    
    /**
    * Function which try to get the current user location.
    */
    public static func getCurrentUserLocation() -> CLLocation {
        return (GeolocationHelper.instance?.locationManager.location!)!
    }
}
