

import Foundation

/**
 * Base class for the identified entities with a basic identifier.
 */
class IdentifiedEntity {
    
    public let id : Int
    
    /**
    * Base constructor for a identified object.
    */
    init (Id id : Int) {
        self.id = id
    }

    /**
    * Empty constructor for new generated identified entities.
    * The identificator must be provided by backend.
    */
    init () {
        self.id = 0
    }
}
