import UIKit

class SerlocRegisterController : UIViewController {

    @IBOutlet weak var newUserEmial: UITextField!
    @IBOutlet weak var newUserPassword: UITextField!
    @IBOutlet weak var newUserFirstName: UITextField!
    @IBOutlet weak var newUserLastName: UITextField!
    @IBOutlet weak var newUserPhoneNumber: UITextField!

    override func viewDidLoad() {
        super.viewDidLoad()

        //Modify the navigation bar title
        self.navigationItem.title = "Register"
        let tapGesture = UITapGestureRecognizer(target: self, action: #selector(self.dismissKeyboard))
        self.view.addGestureRecognizer(tapGesture)

        //This notificated and executes selectors when the keyboard appears/disappear.
        NotificationCenter.default.addObserver(self, selector: #selector(self.showedKeyboard), name:NSNotification.Name.UIKeyboardWillShow, object: nil);
        NotificationCenter.default.addObserver(self, selector: #selector(self.hidedKeyboard), name:NSNotification.Name.UIKeyboardWillHide, object: nil);

    }

    override func viewDidAppear(_ animated: Bool) {
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func submitRegister(_ sender: Any) {
        let userName = newUserFirstName.text! + " " + newUserLastName.text!
        
        let newUser = User(Name: userName,
                           Email: newUserEmial.text!,
                           Password: newUserPassword.text!,
                           PhoneNumber: newUserPhoneNumber.text!)
        
        let successfulRegisterView : UIViewController = (self.storyboard?.instantiateViewController(withIdentifier: "SuccessfulRegisterController"))!
        
        NonAuthenticatedRequestsManager.sendCreateNewUserRequest(NewUser: newUser, FromView: self, ToView: successfulRegisterView)        
    }
    
    /**
    *Function which hides keyboard on tap on screen.
    */
    @objc public func dismissKeyboard (_ sender: UITapGestureRecognizer) {
        newUserEmial.resignFirstResponder()
        newUserPassword.resignFirstResponder()
        newUserFirstName.resignFirstResponder()
        newUserLastName.resignFirstResponder()
        newUserPhoneNumber.resignFirstResponder()
    }
    
    @objc func showedKeyboard(sender: NSNotification) {
        self.view.frame.origin.y = -150
    }
    
    @objc func hidedKeyboard(sender: NSNotification) {
        self.view.frame.origin.y = 0
    }
    
}
