//
//  Service.swift
//  Serloc
//
//  Created by Joaquim Calvo Gubianas on 28/04/2018.
//  Copyright © 2018 Joaquim Calvo Gubianas. All rights reserved.
//

import Foundation
import CoreLocation

class Service : IdentifiedEntity, Decodable {
    
    public let serviceProvider : User
    public var serviceType : ServiceType
    public var name : String
    public var description : String
    public var price : Int
    public var longitude : Float
    public var latitude : Float

    /**
    * Basic service constructor with the
    * default information.
    */
    init(Id id : Int,
         ServiceProvider serviceProvider : User,
         ServiceType serviceType : ServiceType,
         Name name : String,
         Description description : String,
         Price price : Int,
         Longitude longitude : Float,
         Latitude latitude : Float) {
        self.serviceProvider = serviceProvider
        self.serviceType = serviceType
        self.name = name
        self.description = description
        self.price = price
        self.longitude = longitude
        self.latitude = latitude
        super.init(Id : id)
    }
}
