//
//  ServiceJSONParser.swift
//  Serloc
//
//  Created by Joaquim Calvo Gubianas on 11/05/2018.
//  Copyright © 2018 Joaquim Calvo Gubianas. All rights reserved.
//

import Foundation

class ServiceJSONParser {
    
    /**
    * Function which converts a value pair of elements containing serloc service information
    * manage all that fields to generate a new Service instance
    */
    public static func parseJsonToService(SerlocServiceFields fields : [String : AnyObject]) -> Service {
    
        let userJson = fields["serviceProvider"] as! [String : AnyObject]
        let serviceProvider : User = UserJSONParser.parseJsonToUser(UserFields: userJson)
        
        let serviceTypeJson = fields["serviceType"] as! [String : AnyObject]
        let serviceType : ServiceType = ServiceTypeJSONParser.parseJsonToServiceType(ServiceTypeFields: serviceTypeJson)
        
        let id : Int = fields["id"] as! Int
        let name : String = fields["name"] as! String
        let description : String = fields["description"] as! String
        let price : Int = fields["price"] as! Int
        
        let longitudeAsNumber = fields["longitude"] as! NSNumber
        let longitude : Float = longitudeAsNumber.floatValue
        
        let latitudeAsNumber = fields["latitude"] as! NSNumber
        let latitude : Float = latitudeAsNumber.floatValue
        
        return Service(Id: id, ServiceProvider: serviceProvider, ServiceType: serviceType, Name: name, Description: description, Price: price, Longitude: longitude, Latitude: latitude)
    }
    
}
