import Foundation
import UIKit

class UserServiceConsumer {
    
    /**
    * Function which load user information detail from the backend.
    */
    public static func loadUserProfile(Controller controller : MainProfileViewController) {
        let authManager = AuthenticationManager.getInstance()
        let base = URL(string: "http://localhost:8080")!
        let url = base.appendingPathComponent("/secured/user/userDetails")
        var request = authManager.oAuthPasswordGrant.request(forURL: url)
        request.httpMethod = "GET"
        
        authManager.oAuthDataLoader.perform(request: request) { (response) in
            if response.error == nil {
                do {
                    let responseAsJson = try JSONSerialization.jsonObject(with: response.data!, options: JSONSerialization.ReadingOptions.allowFragments) as! [String : AnyObject]

                    let userDetailInformation = responseAsJson["user"] as! [String : AnyObject]
                    let userDetails : User = UserJSONParser.parseJsonToUser(UserFields: userDetailInformation)
                    
                    DispatchQueue.main.async {
                        controller.showUserInformation(UserInformation: userDetails)
                    }
                } catch {
                    
                }
            }
        }
    }
}
