import UIKit
import XCTest

class LoginWithEmailControllerTest : XCTestCase {
    
    override func setUp() {
        //Stop the test when error ocurres
        continueAfterFailure = false
        //Launch the application for every test case.
        XCUIApplication().launch()
    }
    
    override func tearDown() {
        super.tearDown()
    }
    
    /**
     * Test which ensueres the perform of the specific segue when
     * the "Sign with email" button is pressed to redirec to the
     * "LoginWithEmailController" associated view.
     */
    func testOnTapCreatAnAccountMustAppearTheRegisterForm() {
        
        let app = XCUIApplication()
        let element = app.children(matching: .window).element(boundBy: 0).children(matching: .other).element.children(matching: .other).element.children(matching: .other).element.children(matching: .other).element.children(matching: .other).element
        element.tap()
        element.tap()
        app/*@START_MENU_TOKEN@*/.buttons["signWithEmailButton"]/*[[".buttons[\"Sign with email\"]",".buttons[\"signWithEmailButton\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.buttons["createAccountButton"]/*[[".buttons[\"Create an account\"]",".buttons[\"createAccountButton\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        

        XCTAssert(app.textFields["createAccountEmail"].exists)
    }
    
    /**
    * Test which ensures the perform of segue to the services types list controller
    * when the user introduces correctly the credentials and tap the login button.s
    */
    func testOnLoginWithCorrectInformationServicesTypesListMustAppear() {
        
        let app = XCUIApplication()
        let element = app.children(matching: .window).element(boundBy: 0).children(matching: .other).element.children(matching: .other).element.children(matching: .other).element.children(matching: .other).element.children(matching: .other).element
        element.tap()
        
        app/*@START_MENU_TOKEN@*/.buttons["signWithEmailButton"]/*[[".buttons[\"Sign with email\"]",".buttons[\"signWithEmailButton\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.textFields["email"]/*[[".textFields[\"Email\"]",".textFields[\"email\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app.textFields["email"].typeText("joaquim.calvo.gubianas@gmail.com")
        
        app.secureTextFields["password"].tap()
        app/*@START_MENU_TOKEN@*/.secureTextFields["password"]/*[[".secureTextFields[\"Password\"]",".secureTextFields[\"password\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.typeText("admin1234")
        
        element.children(matching: .button).matching(identifier: "Log in").element(boundBy: 0).tap()
        
        XCTAssert(app.buttons["reformsTypeButton"].exists)
    }
    
    /**
    * Test which ensures that a uialert appear if user intrdocues incorrect user
    * credentials.
    */
    func testOnLoginWithBadCredentialsAlertMustAppear() {
        let app = XCUIApplication()
        let element = app.children(matching: .window).element(boundBy: 0).children(matching: .other).element.children(matching: .other).element.children(matching: .other).element.children(matching: .other).element.children(matching: .other).element
        element.tap()
        
        app/*@START_MENU_TOKEN@*/.buttons["signWithEmailButton"]/*[[".buttons[\"Sign with email\"]",".buttons[\"signWithEmailButton\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.textFields["email"]/*[[".textFields[\"Email\"]",".textFields[\"email\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app.textFields["email"].typeText("joaquim.calvo.bianas@gmail.com")
        
        app.secureTextFields["password"].tap()
        app/*@START_MENU_TOKEN@*/.secureTextFields["password"]/*[[".secureTextFields[\"Password\"]",".secureTextFields[\"password\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.typeText("in1234")
        
        element.children(matching: .button).matching(identifier: "Log in").element(boundBy: 0).tap()
        
        XCTAssertEqual(app.alerts.element.label, "Login failure")
    }
}
