import Foundation
import XCTest

class SerlocRegisterControllerTest : XCTestCase{
    
    override func setUp() {
        //Stop the test when error ocurres
        continueAfterFailure = false
        //Launch the application for every test case.
        XCUIApplication().launch()
    }
    
    override func tearDown() {
        super.tearDown()
    }
    
    /**
    * Test which evaluates if the register confirmation appears when the register is applied succesfully.
    */
    func testWhenCorrectInformationIsIntroducedTheRegisterConfirmationMustAppear() {
        
        let currentTime : Double = CACurrentMediaTime();
        let app = XCUIApplication()
        app/*@START_MENU_TOKEN@*/.buttons["signWithEmailButton"]/*[[".buttons[\"Sign with email\"]",".buttons[\"signWithEmailButton\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.buttons["createAccountButton"]/*[[".buttons[\"Create an account\"]",".buttons[\"createAccountButton\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.textFields["registerEmail"]/*[[".textFields[\"Email\"]",".textFields[\"registerEmail\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.textFields["registerEmail"]/*[[".textFields[\"Email\"]",".textFields[\"registerEmail\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.typeText("user\(currentTime)@gmail.com")
        app/*@START_MENU_TOKEN@*/.secureTextFields["registerPassword"]/*[[".secureTextFields[\"Password\"]",".secureTextFields[\"registerPassword\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.secureTextFields["registerPassword"]/*[[".secureTextFields[\"Password\"]",".secureTextFields[\"registerPassword\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.typeText("admin1234")
        app/*@START_MENU_TOKEN@*/.textFields["registerFirstName"]/*[[".textFields[\"First name\"]",".textFields[\"registerFirstName\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.textFields["registerFirstName"]/*[[".textFields[\"First name\"]",".textFields[\"registerFirstName\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.typeText("User test")
        app/*@START_MENU_TOKEN@*/.textFields["registerLastName"]/*[[".textFields[\"Last name\"]",".textFields[\"registerLastName\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.textFields["registerLastName"]/*[[".textFields[\"Last name\"]",".textFields[\"registerLastName\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.typeText("User last name")
        app/*@START_MENU_TOKEN@*/.textFields["registerPhoneNumber"]/*[[".textFields[\"Phone number\"]",".textFields[\"registerPhoneNumber\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        app/*@START_MENU_TOKEN@*/.textFields["registerPhoneNumber"]/*[[".textFields[\"Phone number\"]",".textFields[\"registerPhoneNumber\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.typeText("\(currentTime)")
        app/*@START_MENU_TOKEN@*/.buttons["registerButton"]/*[[".buttons[\"Register\"]",".buttons[\"registerButton\"]"],[[[-1,1],[-1,0]]],[0]]@END_MENU_TOKEN@*/.tap()
        
        XCTAssert(app.buttons["confirmationButton"].exists)
    }
}
